<?php


/**
 * Admin settings form
 */
function ecircleapi_admin_settings() {
  // Run a quick test...
  if (empty($_POST)) {
    // If we've not posted (this stops double-tests), then login to the system.
    $result = ecircleapi_get_client();

    // If the result isn't FALSE, then the login was "ok"
    if ($result !== FALSE) {
      // For now, we create a collapsed fieldset with a list of all SOAP operations.
      $form['ecircleapi_dump'] = array(
        '#type' => 'fieldset',
        '#title' => t('Account Info'),
      );

      $version = $result['client']->call('getVersion');
      $form['ecircleapi_dump']['version'] = array('#type' => 'item', '#title' => t('Version'), '#value' => $version['getVersionReturn']);

      $operations = array_keys($result['client']->operations);
      asort($operations);
      $form['ecircleapi_dump']['operations'] = array('#type' => 'fieldset', '#title' => t('Operations List'), '#collapsible' => TRUE, '#collapsed' => TRUE);
      $form['ecircleapi_dump']['operations']['text'] = array('#type' => 'markup', '#value' => theme('item_list', $operations));
    }
  }


  $form['ecircleapi_url'] = array(
    '#type' => 'textfield',
    '#title' => t('API URL'),
    '#default_value' => variable_get('ecircleapi_url', 'http://webservices.ecircle-ag.com/soap/ecm-ssl.wsdl'),
    '#description' => t('This is the URL to the WSDL which defines the SOAP configuration. The default is probably ok: http://webservices.ecircle-ag.com/soap/ecm.wsdl'),
    '#required' => TRUE,
  );
  $form['ecircleapi_realm'] = array(
    '#type' => 'textfield',
    '#title' => t('Realm'),
    '#default_value' => variable_get('ecircleapi_realm', ''),
    '#required' => TRUE,
    '#description' => t('This value is the installation URL, it would be the domain you use to login to the control panel (eg http://email.example.com/)'),
  );

  $form['ecircleapi_user'] = array(
    '#type' => 'textfield',
    '#title' => t('User'),
    '#default_value' => variable_get('ecircleapi_user', ''),
    '#required' => TRUE,
    '#description' => t('The username and password can be the same as the details you login to the control panel with.'),
  );

  $form['ecircleapi_passwd'] = array(
    '#type' => 'textfield',
    '#title' => t('Password'),
    '#default_value' => variable_get('ecircleapi_passwd', ''),
    '#required' => TRUE,
  );

  $form['ecircleapi_error_reporting'] = array(
    '#type' => 'checkboxes',
    '#title' => t('Error Reporting'),
    '#default_value' => variable_get('ecircleapi_error_reporting', array('watchdog' => 0, 'verbose' => 0)),
    '#options' => array(
      'watchdog' => t('watchdog'),
      'verbose' => t('Verbose (onscreen messages)'),
    ),
    '#description' => t('How much error reporting would you like?'),
  );

  $form['ecircleapi_watchdog_log_all_api'] = array(
    '#type' => 'checkbox',
    '#title' => t('API Logging'),
    '#default_value' => variable_get('ecircleapi_watchdog_log_all_api', 0),
    '#description' => t('Should we log ALL API activity in Watchdog? <strong>Warning: This could make the watchdog VERY large - for debugging only!</strong>'),
  );

  $form['ecircleapi_watchdog_timer_api'] = array(
    '#type' => 'checkbox',
    '#title' => t('API Timer Logging'),
    '#default_value' => variable_get('ecircleapi_watchdog_timer_api', 0),
    '#description' => t('Should we time ALL API activity in Watchdog? <strong>Warning: This could make the watchdog VERY large - for debugging only!</strong>'),
  );

  return system_settings_form($form);
}
